"""
Author: Michel Peltriaux
Organization: Struktur- und Genehmigungsdirektion Nord, Rhineland-Palatinate, Germany
Contact: ksp-servicestelle@sgdnord.rlp.de
Created on: 19.08.22

"""
from django.contrib.auth.decorators import login_required
from django.utils.decorators import method_decorator

from intervention.models import Intervention
from konova.decorators import default_group_required, shared_access_required
from konova.views.deduction import AbstractNewDeductionView, AbstractEditDeductionView, AbstractRemoveDeductionView


class NewInterventionDeductionView(AbstractNewDeductionView):
    def _custom_check(self, obj):
        pass

    model = Intervention
    redirect_url = "intervention:detail"

    @method_decorator(login_required)
    @method_decorator(default_group_required)
    @method_decorator(shared_access_required(Intervention, "id"))
    def dispatch(self, request, *args, **kwargs):
        return super().dispatch(request, *args, **kwargs)


class EditInterventionDeductionView(AbstractEditDeductionView):
    def _custom_check(self, obj):
        pass

    model = Intervention
    redirect_url = "intervention:detail"

    @method_decorator(login_required)
    @method_decorator(default_group_required)
    @method_decorator(shared_access_required(Intervention, "id"))
    def dispatch(self, request, *args, **kwargs):
        return super().dispatch(request, *args, **kwargs)


class RemoveInterventionDeductionView(AbstractRemoveDeductionView):
    def _custom_check(self, obj):
        pass

    model = Intervention
    redirect_url = "intervention:detail"

    @method_decorator(login_required)
    @method_decorator(default_group_required)
    @method_decorator(shared_access_required(Intervention, "id"))
    def dispatch(self, request, *args, **kwargs):
        return super().dispatch(request, *args, **kwargs)
